module.exports = {
  default: `
    Object(shops) {
      image(limitSize): Image [maxSize: 12],
      url(url): URL [regExp: "/^test\/\/\./", errorMsg: "请输入test//."],
      text(foo): Array {
        enum(emum): Enum[multiple: true] {
          a(value A),
          b(value B),
          c(value C),
        },
        title1(title): String [ if: "$.enum == 'a'", minLength: 4, maxLength: 10 ],
        image(image): Image [ if: "$.enum == 'b'" ],
        url(URL): URL [regExp: "/^https:/gi", errorMsg: "必须是 https: 开头"],
        bool(boolean): Boolean,
        num(number): Number [step: 0.1, max: 20, min: 15, if: "$.bool"],
        text(Multline Text): Text [ maxLength: 40 ],
        rtext(RichText): RichText,
        date(Date): Date [ default: "2012-12-12 12:12"],
        color(Color): Color
      },
      file(File): File,
      list(goods): Array [
        maxLength: 5,
        minLength: 2
      ] {
        value(link),
        label(title): String [maxLength: 10],
        img(image[272x272]): Image,
        price(price),
        origin(origin price),
        count(count),
      }
    }`,
  'detail': `
    Object(解决方案详情页面) [
  reuseable: "datasources/1.4.2/solution"
    ] {

      bannerIcon(头部Banner的小图标[推荐尺寸70x70]): Image,
      bannerTitle(头部Banner的标题),
      bannerSummary(头部Banner上对解决方案业务介绍): String[maxLength: 90],
      bannerBg(头部Banner的背景图片[推荐尺寸1440x350]): Image,


      industryValueImg(行业价值大图): Image,
      cvTitle(消费者价值标题): String[default: "消费者价值",maxLength: 6],
      cvSummary(消费者价值描述): String[maxLength: 80],

      isvvTitle(服务商价值标题): String[default: "服务商价值",maxLength: 6],
      isvvSummary(服务商价值描述): String[maxLength: 80],

      mvTitle(商家价值标题): String[default: "商家价值",maxLength: 6],
      mvSummary(商家价值描述): String[maxLength: 80],

      ouploadtext(下载完整介绍):String[maxLength: 6],
      ouploadintro(下载完整介绍链接):URL,

      hot1Show(热门业务1是否显示):Boolean[default: true],
      hot2Show(热门业务2是否显示):Boolean[default: true],
      hot3Show(热门业务3是否显示):Boolean[default: true],
      hot4Show(热门业务4是否显示):Boolean[default: true],
      hot1Icon(热门推荐业务1-商业模式图标[推荐50x50]): Image,
      hot1Title(热门推荐业务1-商业模式名称):String[maxLength: 8],
      hot1Summary(热门推荐业务1-商业模式说明):String[maxLength: 54],

      hot1WhatItems(热门业务1商业模式--我们能做什么介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
        summary(内容): RichText
      },

      hot1HowItems(热门业务1商业模式--怎么做介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
        summary(内容): RichText
      },

      hot1EarnItems(热门业务1商业模式--怎么赚钱介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
        summary(内容): RichText
      },
      hot1ShowEarnItems(热门业务1商业模式--是否显示怎么赚钱): Boolean[default: true],

      hot1CaseItems(热门推荐业务1-成功案例列表): Array{
        icon(案例图标[推荐50x50]): Image,
        title(成功案例名称):String[maxLength: 8],
        summary(成功案例说明):String[maxLength: 80],
        screenshot(成功案例截图): Image,
        url(成功案例的详情链接): URL
      },
      hot1MoreCasesText(热门推荐业务1-更多成功案例文本): String[maxLength: 6,default:""],
      hot1MoreCasesLink(热门推荐业务1-更多成功案例的链接): URL,

      hot1JoinText(热门推荐业务1-立即接入文本): String[maxLength: 4,default:""],
      hot1JoinLink(热门推荐业务1-立即接入的链接): URL,
      hot1JoinSteps(热门推荐业务1-接入步骤各个步骤): Array[maxLength: 5]{
        icon(步骤图标[推荐36x36]): Image,
        title(步骤名称),
        summary(步骤说明): RichText
      },

      hot2Icon(热门推荐业务2-商业模式图标[推荐50x50]): Image,
      hot2Title(热门推荐业务2-商业模式名称):String[maxLength: 8],
      hot2Summary(热门推荐业务2-商业模式说明):String[maxLength: 54],

      hot2WhatItems(热门业务2商业模式--我们能做什么介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
        summary(内容): RichText
      },

      hot2HowItems(热门业务2商业模式--怎么做介绍): Array[maxLength: 3]{
       title(标题):String[maxLength: 20],
       summary(内容): RichText
      },

      hot2EarnItems(热门业务2商业模式--怎么赚钱介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
        summary(内容): RichText
      },
      hot2ShowEarnItems(热门业务2商业模式--是否显示怎么赚钱): Boolean[default: true],

      hot2CaseItems(热门推荐业务2-成功案例列表): Array{
        icon(案例图标[推荐50x50]): Image,
        title(成功案例名称):String[maxLength: 8],
            summary(成功案例说明):String[maxLength: 80],
        screenshot(成功案例截图): Image,
        url(成功案例的详情链接): URL
      },
      hot2MoreCasesText(热门推荐业务2-更多成功案例文本): String[maxLength: 6,default:""],
      hot2MoreCasesLink(热门推荐业务2-更多成功案例的链接): URL,

      hot2JoinText(热门推荐业务2-立即接入文本): String[maxLength: 4,default:""],
      hot2JoinLink(热门推荐业务2-立即接入的链接): URL,
      hot2JoinSteps(热门推荐业务2-接入步骤各个步骤): Array{
        icon(步骤图标[推荐76x76]): Image,
        title(步骤名称),
        summary(步骤说明): RichText
      },


      hot3Icon(热门推荐业务3-商业模式图标[推荐50x50]): Image,
      hot3Title(热门推荐业务3-商业模式名称):String[maxLength: 8],
      hot3Summary(热门推荐业务3-商业模式说明):String[maxLength: 54],

      hot3WhatItems(热门业务3商业模式--我们能做什么介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
           summary(内容): RichText
      },

      hot3HowItems(热门业务3商业模式--怎么做介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
           summary(内容): RichText
      },

      hot3EarnItems(热门业务3商业模式--怎么赚钱介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
           summary(内容): RichText
      },
      hot3ShowEarnItems(热门业务3商业模式--是否显示怎么赚钱): Boolean[default: true],

      hot3CaseItems(热门推荐业务3-成功案例列表): Array{
        icon(案例图标[推荐50x50]): Image,
        title(成功案例名称):String[maxLength: 8],
            summary(成功案例说明):String[maxLength: 80],
        screenshot(成功案例截图): Image,
        url(成功案例的详情链接): URL
      },
      hot3MoreCasesText(热门推荐业务3-更多成功案例文本): String[maxLength: 6,default:""],
      hot3MoreCasesLink(热门推荐业务3-更多成功案例的链接): URL,

      hot3JoinText(热门推荐业务3-立即接入文本): String[maxLength: 4,default:""],
      hot3JoinLink(热门推荐业务3-立即接入的链接): URL,
      hot3JoinSteps(热门推荐业务3-接入步骤各个步骤): Array{
        icon(步骤图标[推荐76x76]): Image,
        title(步骤名称),
        summary(步骤说明): RichText
      },


      hot4Icon(热门推荐业务4-商业模式图标[推荐50x50]): Image,
      hot4Title(热门推荐业务4-商业模式名称):String[maxLength: 8],
      hot4Summary(热门推荐业务4-商业模式说明):String[maxLength: 54],

      hot4WhatItems(热门业务4商业模式--我们能做什么介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
           summary(内容): RichText
      },

      hot4HowItems(热门业务4商业模式--怎么做介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
           summary(内容): RichText
      },

      hot4EarnItems(热门业务4商业模式--怎么赚钱介绍): Array[maxLength: 3]{
        title(标题):String[maxLength: 20],
           summary(内容): RichText
      },
     hot4ShowEarnItems(热门业务4商业模式--是否显示怎么赚钱): Boolean[default: true],
      hot4CaseItems(热门推荐业务4-成功案例列表): Array{
        icon(案例图标[推荐50x50]): Image,
       title(成功案例名称):String[maxLength: 8],
           summary(成功案例说明):String[maxLength: 80],
        screenshot(成功案例截图): Image,
        url(成功案例的详情链接): URL
      },
      hot4MoreCasesText(热门推荐业务4-更多成功案例文本): String[maxLength: 6,default:""],
      hot4MoreCasesLink(热门推荐业务4-更多成功案例的链接): URL,

      hot4JoinText(热门推荐业务4-立即接入文本): String[maxLength: 4,default:""],
      hot4JoinLink(热门推荐业务4-立即接入的链接): URL,
      hot4JoinSteps(热门推荐业务4-接入步骤各个步骤): Array{
        icon(步骤图标[推荐76x76]): Image,
        title(步骤名称),
        summary(步骤说明): RichText
      }
    }
  `,
  koubei: `
    Object(口碑品牌数据) {
      list(商家列表):Array {
        name(商家名称),
        pic(图片地址)
      },

      itemType1(单品数据1): Object {
         list(列表):Array{
          name(商家名称),
          pic(图片地址),
          num(销量),
         },
         type(单品类型),
      },
      itemType2(单品数据2): Object {
         list(列表):Array {
          name(商家名称),
          pic(图片地址),
          num(销量)
         },
         type(单品类型)
      },
      itemType3(单品数据3): Object {
         list(列表): Array {
          name(商家名称),
          pic(图片地址),
          num(销量)
         },
         type(单品类型)
      }
    }
  `,
  enums: `
    Object(enums) {
      enumNormal(普通选择, 单选): Enum {
        apple(苹果),
        pear(梨),
        watermelon(西瓜)
      },
      enumSourceNormal(锚点选择, 单选): Enum [ source: "urls" ],
      urls(urls): Array {
        label(名字)
        value(链接)
      },
      enumSourceMultiple(锚点选择, 多选): Enum [ source: "newurls", multiple: true ],
      newurls(urls): Array {
        label(名字)
        value(链接)
      },
      enumMultiple(多选): Enum[ multiple: true ] {
        apple(苹果),
        pear(梨),
        watermelon(西瓜)
      },
    }
  `,
  arrayNest: `
    Array(banner图片) {
      img(图片[640x324]): Image
      url(banner地址)
      list(item): Array {
        href(宝贝链接),
        bar(xxx): Array {
          title1(标题),
          img(图片地址[272x272]): Image,
          price(花呗价格),
          origin(原价),
        }
        title1(标题),
        img(图片地址[272x272]): Image,
        price(花呗价格),
        origin(原价),
      }
      checked(是否开启xx): Boolean
    }
  `,
  gasConfig: `
    Object(加油服务配置) {
      pageType(加油服务配置):Array {
        province(省份拼音),
        componentId(省份数据): component
      },
      cityType(城市对省份匹配):Array {
        cityname(城市),
        province(对应的省份拼音)
      },
      cityCodeType(城市码对省份匹配):Array {
        cityCode(城市码),
        province(对应的省份拼音)
      },
      anPilotCity(安代驾支持的城市):Array {
        cityname(城市名)
      },
      didiPilotCity(滴滴代驾支持的城市):Array {
        cityname(城市名)
      },
      violationForCx580(行车易支持的城市):Array {
        cityname(城市名)
      }
    }
  `,

  provinces: `
    Object(省份配置) {
      banner(广告运营位): Array {
        href(链接),
        img(图片地址[649x150]): Image
      },
      oilData(加油服务商配置):Array {
        name(服务商名称),
        url(对应的URL),
        logo(logo地址),
        explain(介绍文案),
        explainClass(额外样式),
        publicId(RT),
        seedId(埋点ID),
        ribbon(角标),
        status(应用状态): Enum {
          active(在用),
          unactive(下线),
          maint(维护中)
        }
      },
      nearby(附近加油站配置):Array {
        name(服务商名称),
        url(对应的URL),
        logo(logo地址),
        explain(介绍文案),
        explainClass(额外样式),
        publicId(RT),
        seedId(埋点ID),
        ribbon(角标),
        status(应用状态): Enum {
          active(在用),
          unactive(下线),
          maint(维护中)
        }
      },
      recommend(推荐服务商配置):Array {
        name(服务商名称),
        url(对应的URL),
        logo(logo地址),
        publicId(RT),
        seedId(埋点ID),
        ribbon(角标),
        status(应用状态): Enum {
          active(在用),
          unactive(下线),
          maint(维护中)
        }
      }
    }
  `,
  level2: `
    Object(大牌劲爆商品) {
      text(说明): Object {
        title(标题): String [ minLength: 4, maxLength: 10 ],
        image(图片): Image,
        url(URL): URL [regExp: "/^https:/gi", errorMsg: "必须是 https: 开头"],
        bool(布尔): Boolean,
        text(多行文本): Text [ maxLength: 40 ],
        rtext(富文本): RichText,
        date(日期): Date,
        color(颜色): Color,
        enum(枚举): Enum {
          a(值A),
          b(值B)
        }
      },
      file(文件): File
    }
  `,
  level3: `
    Object(bar配置) {
      leftIcon(左侧图标): Object {
        action(跳转链接): String [default:  "mybank: //setting/userInfoProfile"],
          name(名字): String [default:  "leftIcon"],
          image(图片): Object{
            name(名字): String[default:  "header_left_icon"],
            url(链接): String[minLength:  2],
            height(高度): Number[default: 0],
            width(宽度): Number[default: 0]
          }
      },
      middleIcon(中间图标):Object {
        name(名字): String [ default: "middleIcon"],
        image(图片): Object {
          name(名字): String [default: "header_left_icon"],
          url(链接): String [minLength: 2],
          height(高度): Number [default:0],
          width(宽度): Number [default:0]
        }
      }
    }
    `,
  level4: `
    Object(tools配置) {
      title(标题),
      items(入口列表): Array{
        action(跳转链接):String [default: "mybank://h5app/offline?appId=20000223"],
          image(图片):Object{
            name(名字):String[default: "header_left_icon"],
            url(链接):String[default:""],
            height(高度):Number[default:0],
            width(宽度):Number[default:0]
          },
          name(名字):String [default: "leftIcon"]
      }
    }`,
  model: require('./model.schema'),
};