'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SortArray = undefined;

var _alert = require('antd/lib/alert');

var _alert2 = _interopRequireDefault(_alert);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSortableHoc = require('react-sortable-hoc');

var _schemaUtil = require('schema-util');

var _schemaUtil2 = _interopRequireDefault(_schemaUtil);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _array_item = require('./array_item');

var _array_item2 = _interopRequireDefault(_array_item);

var _excel_button = require('./excel_button');

var _excel_button2 = _interopRequireDefault(_excel_button);

var _clone = require('../util/clone');

var _clone2 = _interopRequireDefault(_clone);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 数组列表区域
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright(c) Alibaba Group Holding Limited.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * MIT Licensed
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var MAX_ARRAY_ITEM_LENGTH = 500;

var FieldArray = function (_React$Component) {
  _inherits(FieldArray, _React$Component);

  function FieldArray() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FieldArray);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FieldArray.__proto__ || Object.getPrototypeOf(FieldArray)).call.apply(_ref, [this].concat(args))), _this), _this.onUploadSuccess = function (data) {
      _this.props.onUploadSuccess({
        value: data,
        fields: [_this.props.field],
        type: 'array-import'
      });
    }, _this.onExcelBtnClick = function (data) {
      if (_this.props.onClick) {
        _this.props.onClick(data);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FieldArray, [{
    key: 'displayAddButton',

    // 添加按钮
    value: function displayAddButton() {
      var _props = this.props,
          schema = _props.schema,
          data = _props.data,
          config = _props.config;

      if (schema.meta && Array.isArray(data)) {
        var arrLength = data.length;
        var maxLength = schema.meta.maxLength ? schema.meta.maxLength : null;
        if (maxLength === arrLength) {
          return _react2.default.createElement(
            'p',
            null,
            config.locale.ARRAY_MAX_LENGHT_ERROR.replace('%s', maxLength)
          );
        }
      }
      return _react2.default.createElement(
        'div',
        { className: 'add-btn' },
        _react2.default.createElement(
          'a',
          { onClick: this.props.addItem },
          _react2.default.createElement(_icon2.default, { type: 'plus' }),
          config.locale.ADD_ARRAY_ITEM
        )
      );
    }
  }, {
    key: 'renderItems',
    value: function renderItems(isPlainObject) {
      var _this2 = this;

      var _props2 = this.props,
          actives = _props2.actives,
          data = _props2.data,
          schema = _props2.schema,
          config = _props2.config;

      var json = (0, _objectAssign2.default)({}, schema, { type: 'object' });

      if (!Array.isArray(data) || !data.length) {
        return null;
      }

      var itemLength = data.length;
      var hasExtras = false;
      var isHideDelete = false; // 是否显示删除按钮
      if (schema.meta && schema.meta.minLength && data.length <= schema.meta.minLength) {
        isHideDelete = true;
      }

      var ret = data.map(function (item, index) {
        if (index > MAX_ARRAY_ITEM_LENGTH && isPlainObject) {
          hasExtras = true;
          return null;
        }

        return _react2.default.createElement(_array_item2.default, {
          key: index,
          index: index,
          field: index,
          itemLength: itemLength,
          disabled: actives[index] && isPlainObject,
          isActived: actives[index] && isPlainObject,
          schema: json,
          data: item,
          isHideDelete: isHideDelete,
          onChange: _this2.props.onChange,
          copyItem: _this2.props.copyItem(index),
          deleteItem: _this2.props.deleteItem(index),
          toggleItem: _this2.props.toggleItem,
          collapseItems: _this2.props.collapseItems,
          config: config
        });
      });

      if (hasExtras) {
        ret.push(_react2.default.createElement(
          'div',
          { className: 'row row-extras', key: 'extra' },
          _react2.default.createElement(_alert2.default, { message: config.locale.ARRAY_TOO_LONG_WARN, type: 'warning', showIcon: true })
        ));
      }

      return ret;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          schema = _props3.schema,
          data = _props3.data,
          config = _props3.config,
          field = _props3.field,
          isNotPlainObject = _props3.isNotPlainObject;

      var isPlainObject = !isNotPlainObject;

      var excelBtn = config.excelImport && isPlainObject ? _react2.default.createElement(_excel_button2.default, {
        data: data,
        schema: schema,
        title: schema.description,
        errorList: this.props.errorList,
        onUploadSuccess: this.onUploadSuccess,
        onClick: this.onExcelBtnClick,
        locale: config.locale
      }) : null;
      var fieldCls = field ? 'has-field' : '';

      return _react2.default.createElement(
        'div',
        { className: 'ui-form-item field-array ' + fieldCls },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            {
              className: 'ui-label-title',
              title: field && schema.description || null
            },
            field && schema.description || null
          ),
          excelBtn
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content', key: field },
          _react2.default.createElement(
            'div',
            { className: 'item-array' },
            this.renderItems(isPlainObject)
          ),
          this.displayAddButton()
        )
      );
    }
  }]);

  return FieldArray;
}(_react2.default.Component);

var Sortable = (0, _reactSortableHoc.SortableContainer)(function (props) {
  return _react2.default.createElement(FieldArray, props);
});

var SortArray = exports.SortArray = function (_React$Component2) {
  _inherits(SortArray, _React$Component2);

  function SortArray(props) {
    _classCallCheck(this, SortArray);

    var _this3 = _possibleConstructorReturn(this, (SortArray.__proto__ || Object.getPrototypeOf(SortArray)).call(this, props));

    _this3.handleToggleItem = function (index) {
      return function (ev) {
        ev.stopPropagation();
        ev.preventDefault();

        // 直接代开二级面板
        if (_this3.isNotPlainObject) {
          // 激活二级
          return _this3.onChange({ selected: true, fields: [index] });
        }

        var actives = _this3.state.actives;
        _this3.setState({
          actives: _defineProperty({}, index, !actives[index])
        });
      };
    };

    _this3.handleDeleteItem = function (index) {
      return function (ev) {
        var field = _this3.props.field;
        var data = _this3.props.data.slice();
        data.splice(index, 1);

        _this3.props.onChange({
          value: data,
          fields: [field],
          type: 'array-delete',
          schema: _this3.props.schema
        });

        ev.stopPropagation();
        ev.preventDefault();
      };
    };

    _this3.handleAddItem = function () {
      var _this3$props = _this3.props,
          field = _this3$props.field,
          onChange = _this3$props.onChange,
          data = _this3$props.data,
          schema = _this3$props.schema;

      var len = data ? data.length : 0;
      var self = _this3;
      // clone data
      // default empty array
      var newData = data ? data.slice() : [];
      newData.push(_this3.resetBoxData(schema.properties, _this3.getNewItem()));

      onChange({
        value: newData,
        fields: [field],
        type: 'array-add',
        schema: schema
      });

      setTimeout(function () {
        self.setState({
          actives: _defineProperty({}, len, true)
        });
      }, 100);
    };

    _this3.handleChange = function (e) {
      var field = _this3.props.field;
      if (field !== undefined) {
        e.fields.unshift(field);
      }

      _this3.props.onChange(e);
    };

    _this3.handleSortItem = function (_ref2) {
      var oldIndex = _ref2.oldIndex,
          newIndex = _ref2.newIndex;

      // clone
      var data = _this3.props.data.slice();
      data = (0, _reactSortableHoc.arrayMove)(data, oldIndex, newIndex);

      _this3.props.onChange({
        value: data,
        fields: [_this3.props.field],
        type: 'array-sort'
      });
    };

    _this3.handleCopyItem = function (index) {
      var _this3$props2 = _this3.props,
          field = _this3$props2.field,
          onChange = _this3$props2.onChange,
          data = _this3$props2.data,
          schema = _this3$props2.schema;

      var len = index + 1;

      return function (ev) {
        var originData = data.slice();
        var newData = originData[index];

        if (!newData) {
          return;
        }

        originData.splice(index, 0, _this3.resetBoxData(schema.properties, newData));

        onChange({
          value: originData,
          fields: [field],
          type: 'array-add',
          schema: schema
        });

        setTimeout(function () {
          _this3.setState({
            actives: _defineProperty({}, len, true)
          });
        }, 100);

        ev.stopPropagation();
        ev.preventDefault();
      };
    };

    _this3.handleUploadSuccess = function (e) {
      _this3.props.onChange(e);
    };

    _this3.isNotPlainObject = Object.keys(props.schema.properties).some(function (o) {
      return ['array', 'object'].indexOf(props.schema.properties[o].type) > -1;
    });

    _this3.state = { actives: {} };
    return _this3;
  }

  // 生成随机 uid


  _createClass(SortArray, [{
    key: 'genUID',
    value: function genUID() {
      return (Date.now() + Math.random().toString().substr(2, 3)).replace(/^(\d{4})(\d{4})(\d{4})(\d{4})/g, '$1-$2-$3-$4');
    }

    /*
     * @param {Object} properties schema 的 properties
     * @param {Object} 需要更新 uuid 的数据
     * @return {Object} 更新后的数据
     * 复制一个 array 项时， 针对 box 类型的特殊处理
     * - 删除 uuid, uuid应该是自动生成的
     * - left, top 位置偏移，避免多个重叠在一起
     */

  }, {
    key: 'resetBoxData',
    value: function resetBoxData(properties, itemData) {
      var _this4 = this;

      var newItemData = (0, _clone2.default)(itemData);

      Object.keys(properties).forEach(function (key) {
        if (properties[key].type === 'box') {
          newItemData[key].uid = _this4.genUID();
          // 增加偏移
          newItemData[key].left += 10;
          newItemData[key].top += 10;
        }
      });

      return newItemData;
    }

    // 收起所有条目

  }, {
    key: 'handleCollapseItems',
    value: function handleCollapseItems() {
      this.setState({
        actives: {}
      });
    }

    // 展开&收起一个条目，展开时其他条目收起


    // 删除条目

  }, {
    key: 'getNewItem',
    value: function getNewItem() {
      var data = this.props.data;
      if (data && data.length) {
        return (0, _objectAssign2.default)((0, _clone2.default)(data[0]), { __key: undefined });
      }

      var mockData = _schemaUtil2.default.mock(this.props.schema);
      mockData[0].__key = undefined;
      return mockData[0];
    }

    // 新增一个条目


    // 修改内容


    // 组件排序


    // 复制数组项


    // excel 上传成功

  }, {
    key: 'onChange',
    value: function onChange(e) {
      var field = this.props.field;

      if (field !== undefined) {
        e.fields.unshift(field);
      }

      this.props.onChange(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      return _react2.default.createElement(Sortable, _extends({
        axis: 'y',
        lockAxis: 'y',
        helperClass: 'schema-editor-array-item-dragging',
        onSortEnd: this.handleSortItem,
        useDragHandle: true
      }, props, {
        actives: this.state.actives,
        onUploadSuccess: this.handleUploadSuccess,
        onChange: this.handleChange,
        addItem: this.handleAddItem,
        isNotPlainObject: this.isNotPlainObject,
        copyItem: this.handleCopyItem,
        deleteItem: this.handleDeleteItem,
        toggleItem: this.handleToggleItem,
        collapseItems: this.handleCollapseItems
      }));
    }
  }]);

  return SortArray;
}(_react2.default.Component);

exports.default = SortArray;