'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tooltip = require('antd/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactSortableHoc = require('react-sortable-hoc');

var _object = require('./object');

var _object2 = _interopRequireDefault(_object);

var _getArrayTitle = require('../util/getArrayTitle');

var _getArrayTitle2 = _interopRequireDefault(_getArrayTitle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DragHandle = (0, _reactSortableHoc.SortableHandle)(function (props) {
  var cls = (0, _classnames2.default)('row-drag', {
    'row-drag-disable': props.disable === true
  });
  return _react2.default.createElement('a', { className: cls });
});

var ArrayItem = function (_React$Component) {
  _inherits(ArrayItem, _React$Component);

  function ArrayItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ArrayItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ArrayItem.__proto__ || Object.getPrototypeOf(ArrayItem)).call.apply(_ref, [this].concat(args))), _this), _this.handlePreventDefault = function (ev) {
      ev.stopPropagation();
      ev.preventDefault();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ArrayItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          field = _props.field,
          itemLength = _props.itemLength,
          isActived = _props.isActived,
          schema = _props.schema,
          data = _props.data,
          deleteItem = _props.deleteItem,
          copyItem = _props.copyItem,
          toggleItem = _props.toggleItem,
          config = _props.config;

      var _Object$assign = Object.assign({}, { minLength: null, maxLength: null }, _extends({}, schema.meta)),
          minLength = _Object$assign.minLength,
          maxLength = _Object$assign.maxLength;

      var boxCls = (0, _classnames2.default)('row', { active: isActived });

      var rootData = config ? config.rootData : {};
      var title = (0, _getArrayTitle2.default)(data, schema, rootData);
      var panel = isActived ? _react2.default.createElement(_object2.default, {
        schema: schema,
        data: data,
        field: field,
        onChange: this.props.onChange,
        config: config
      }) : null;

      return _react2.default.createElement(
        'div',
        { key: field, className: boxCls },
        _react2.default.createElement(
          'div',
          { className: 'title', onClick: toggleItem(field) },
          _react2.default.createElement(
            'div',
            { className: 'row-title' },
            _react2.default.createElement(DragHandle, { disable: isActived }),
            _react2.default.createElement(
              'span',
              null,
              title
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'row-options' },
            isActived ? null : _react2.default.createElement(
              'span',
              { className: 'row-edit', onClick: toggleItem(field) },
              _react2.default.createElement(_icon2.default, { type: 'edit' })
            ),

            /* 数组长度 >= 最大限制时不显示复制按钮 */
            maxLength && itemLength >= maxLength ? _react2.default.createElement(
              _tooltip2.default,
              { overlayClassName: 'schema-editor-tips', placement: 'top', title: '\u6700\u591A\u80FD\u589E\u52A0' + maxLength + '\u6761\u6570\u636E' },
              _react2.default.createElement(
                'span',
                { className: 'row-copy row-copy-disable', onClick: this.handlePreventDefault },
                _react2.default.createElement(_icon2.default, { type: 'copy' })
              )
            ) : _react2.default.createElement(
              'span',
              { className: 'row-copy', onClick: copyItem },
              _react2.default.createElement(_icon2.default, { type: 'copy' })
            ),

            /* 数组长度 <= 最小限制时不显示删除按钮 */
            minLength && itemLength <= minLength ? _react2.default.createElement(
              _tooltip2.default,
              { overlayClassName: 'schema-editor-tips', placement: 'top', title: '\u6700\u5C11\u9700\u8981\u4FDD\u7559' + minLength + '\u6761\u6570\u636E' },
              _react2.default.createElement(
                'span',
                { className: 'row-delete row-delete-disable', onClick: this.handlePreventDefault },
                _react2.default.createElement(_icon2.default, { type: 'delete' })
              )
            ) : _react2.default.createElement(
              'span',
              { className: 'row-delete', onClick: deleteItem },
              _react2.default.createElement(_icon2.default, { type: 'delete' })
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'results', ref: 'panel-' + field },
          panel
        )
      );
    }
  }]);

  return ArrayItem;
}(_react2.default.Component);

exports.default = (0, _reactSortableHoc.SortableElement)(ArrayItem);