'use strict';

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

var _reactColor = require('react-color');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tinyColor = require('react-color/modules/tinycolor2');

/**
 * 颜色输入框
 *  - 输入格式
 *   - 支持 hex, rgb, rgba 等各种格式输入
 *   - hex 格式输入，带不带 `#` 都支持
 *  - 存储
 *   - 使用 rgb(a) 格式存储，支持 alpha 通道
 *   - 初始化时支持各种格式输入
 *
 * @access public
 * @param { Object } props props
 * @return { ColorPicker } color-picker component
 */
module.exports = function (_ref) {
  var field = _ref.field,
      schema = _ref.schema,
      _onChange = _ref.onChange,
      data = _ref.data;

  var colorString = data || 'rgba(0, 0, 0, 1)';

  var popoverProps = {
    overlayClassName: 'color-picker',
    placement: 'bottom',
    trigger: 'click',
    content: _react2.default.createElement(_reactColor.SketchPicker, {
      presetColors: [],
      color: tinyColor(colorString),
      onChange: function onChange(_ref2) {
        var rgb = _ref2.rgb;
        return _onChange({
          value: tinyColor(rgb).toRgbString(),
          fields: [field]
        });
      }
    })
  };

  var description = schema.meta && schema.meta.description ? _react2.default.createElement(
    _text2.default,
    { showTooltip: true },
    schema.meta.description
  ) : null;

  return _react2.default.createElement(
    'div',
    { className: 'ui-form-item field-color', key: field },
    _react2.default.createElement(
      'div',
      { className: 'ui-label', title: field },
      _react2.default.createElement(
        'span',
        { className: 'ui-label-title', title: schema.description },
        schema.description
      ),
      description
    ),
    _react2.default.createElement(
      'div',
      { className: 'ui-content' },
      _react2.default.createElement(
        _popover2.default,
        popoverProps,
        _react2.default.createElement(
          'div',
          { className: 'swatch' },
          _react2.default.createElement('i', { className: 'color', style: { background: colorString } }),
          _react2.default.createElement(
            'span',
            { className: 'color-string' },
            colorString
          )
        )
      )
    )
  );
};