'use strict';

var _datePicker = require('antd/lib/date-picker');

var _datePicker2 = _interopRequireDefault(_datePicker);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var moment = require('moment');

var DateField = function (_React$Component) {
  _inherits(DateField, _React$Component);

  function DateField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DateField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DateField.__proto__ || Object.getPrototypeOf(DateField)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (date) {
      var field = _this.props.field;
      // - 统一返回时间戳，例如 1462421539675
      var value = new Date(date).getTime();
      _this.props.onChange({ value: value, fields: [field] });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DateField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          schema = _props.schema,
          data = _props.data,
          field = _props.field;

      var label = schema.description;
      var name = field;
      // support number or 'number' string or 'YYYY-mm-dd HH:mm' date string
      var dt = new Date(+data || data);
      var date = isNaN(dt) ? new Date() : dt;

      var description = schema.meta && schema.meta.description ? _react2.default.createElement(
        _text2.default,
        { showTooltip: true },
        schema.meta.description
      ) : null;

      return _react2.default.createElement(
        'div',
        { className: 'ui-form-item field-string', key: name },
        _react2.default.createElement(
          'div',
          { className: 'ui-label', title: name },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: label },
            label
          ),
          description
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content' },
          _react2.default.createElement(_datePicker2.default, {
            showTime: true,
            dropdownClassName: 'schema-editor-data-picker',
            format: 'YYYY-MM-DD HH:mm',
            onChange: this.onChange, value: moment(date) })
        )
      );
    }
  }]);

  return DateField;
}(_react2.default.Component);

module.exports = DateField;