'use strict';

var _select = require('antd/lib/select');

var _select2 = _interopRequireDefault(_select);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Option = _select2.default.Option;

var Enums = function (_React$Component) {
  _inherits(Enums, _React$Component);

  function Enums() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Enums);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Enums.__proto__ || Object.getPrototypeOf(Enums)).call.apply(_ref, [this].concat(args))), _this), _this.handleSelect = function (value) {
      var field = _this.props.field;
      _this.props.onChange({ value: value, fields: [field] });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Enums, [{
    key: 'getItems',
    value: function getItems() {
      var _props = this.props,
          schema = _props.schema,
          parentData = _props.parentData,
          config = _props.config;

      var source = schema.meta ? schema.meta.source : null;
      if (source) {
        var rootData = parentData;

        var ROOT = '$root.';
        if (source.indexOf(ROOT) === 0) {
          rootData = config.rootData;
          if (Array.isArray(rootData) && config.paths.length) {
            rootData = rootData[config.paths[0]];
          }
          source = source.slice(ROOT.length);
        }

        if (Array.isArray(rootData[source])) {
          return rootData[source];
        }
      }
      return schema.items;
    }
  }, {
    key: 'getSelect',
    value: function getSelect() {
      var _props2 = this.props,
          data = _props2.data,
          schema = _props2.schema;

      var items = this.getItems();

      // 是否是多选
      var multiple = !!(schema.meta && schema.meta.multiple === true);
      // 被选中的项的描述，如果没有，则选第一个
      var selectValueName = multiple ? [] : undefined;

      var values = {};
      var options = items.map(function (item, i) {
        var val = item.value;
        // 清空重复的数据
        if (values[val]) {
          return null;
        }

        values[val] = true;

        if ([].concat(data).indexOf(item.value) !== -1) {
          if (multiple) {
            selectValueName.push(item.value);
          } else {
            selectValueName = item.value;
          }
        }
        return _react2.default.createElement(
          Option,
          { value: item.value, key: i },
          item.label
        );
      }).filter(function (o) {
        return o;
      });

      var modeProps = multiple ? {
        mode: 'multiple'
      } : {};

      // 下拉选择器，当选项数量超过 5 个的时候显示过滤框
      return _react2.default.createElement(
        _select2.default,
        _extends({
          allowClear: true,
          showSearch: true,
          dropdownClassName: 'schema-editor-select-option',
          placeholder: '\u8BF7\u8F93\u5165\u5173\u952E\u5B57\u8FDB\u884C\u7B5B\u9009',
          optionFilterProp: 'children',
          notFoundContent: '\u65E0\u6CD5\u627E\u5230',
          style: { width: '100%' },
          value: selectValueName,
          onChange: this.handleSelect
        }, modeProps),
        options
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var schema = this.props.schema;


      var description = schema.meta && schema.meta.description ? _react2.default.createElement(
        _text2.default,
        { showTooltip: true },
        schema.meta.description
      ) : null;

      return _react2.default.createElement(
        'div',
        { className: 'url-input ui-form-item' },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: schema.description },
            schema.description
          ),
          description
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content' },
          this.getSelect()
        )
      );
    }
  }]);

  return Enums;
}(_react2.default.Component);

module.exports = Enums;