'use strict';

var _upload = require('antd/lib/upload');

var _upload2 = _interopRequireDefault(_upload);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _popover = require('antd/lib/popover');

var _popover2 = _interopRequireDefault(_popover);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _form2.default.Item;

// 支持的类型
var fileContentTypes = ['text/html', 'audio/mpeg'];

var File = function (_React$Component) {
  _inherits(File, _React$Component);

  function File(props) {
    _classCallCheck(this, File);

    var _this = _possibleConstructorReturn(this, (File.__proto__ || Object.getPrototypeOf(File)).call(this, props));

    _this.beforeUpload = function (file) {
      if (fileContentTypes.indexOf(file.type) === -1) {
        _this.setState({
          errorMsg: '不支持该类型的文件'
        });
      } else if (file.type === 'text/html') {
        _this.setState({
          errorMsg: ''
        });
        _this.readFile(file);
      }
      return false;
    };

    _this.handlerProcess = function (info) {
      var status = info.file.status;

      switch (status) {
        case 'error':
          {
            _this.setState({
              errorMsg: info.file.response
            });
            break;
          }
        case 'done':
          {
            // 清除出错状态
            _this.setState({ errorMsg: '', success: true });
            setTimeout(function () {
              _this.setState({
                success: false
              });
            }, 2000);
            var field = _this.props.field;
            _this.props.onChange({
              value: info.file.response.url,
              fields: [field]
            });
            break;
          }
        default:
          {
            break;
          }
      }
    };

    _this.handleFileNameChange = function () {};

    _this.state = {
      errorMsg: '',
      fileName: ''
    };
    return _this;
  }

  _createClass(File, [{
    key: 'readFile',
    value: function readFile(file) {
      var reader = new FileReader();
      var self = this;
      var field = this.props.field;

      reader.onloadend = function (evt) {
        if (evt.target.readyState === FileReader.DONE) {
          var html = '' + evt.target.result;
          self.props.onChange({ value: html, fields: [field] });
        }
      };
      reader.onerror = function (e) {
        self.setState({
          errorMsg: '\u6587\u4EF6\u8BFB\u53D6\u9519\u8BEF ' + e
        });
      };
      reader.readAsText(file);

      this.setState({
        fileName: '\u5DF2\u9009\u62E9 ' + file.name
      });
    }
  }, {
    key: 'render',
    value: function render() {
      // 活动创建异常时的提示信息
      var errorMsg = this.state.errorMsg;
      var fileName = this.state.fileName;
      var _props = this.props,
          schema = _props.schema,
          config = _props.config;


      return _react2.default.createElement(
        'div',
        { className: 'ui-form-item item-file' },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: schema.description },
            schema.description
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content' },
          _react2.default.createElement(
            _popover2.default,
            {
              content: errorMsg,
              placement: 'top',
              visible: !!errorMsg
            },
            _react2.default.createElement(
              FormItem,
              {
                hasFeedback: true,
                validateStatus: errorMsg === '' ? '' : 'error'
              },
              _react2.default.createElement(_input2.default, { size: config.size, value: fileName, onChange: this.handleFileNameChange })
            )
          ),
          _react2.default.createElement(
            _upload2.default,
            {
              action: '/api/upload',
              onChange: this.handlerProcess,
              beforeUpload: this.beforeUpload
            },
            _react2.default.createElement(
              'a',
              { href: '#nowhere' },
              _react2.default.createElement(_icon2.default, { type: 'upload' }),
              schema.description
            )
          )
        )
      );
    }
  }]);

  return File;
}(_react2.default.Component);

module.exports = File;