'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; // 这里在服务器渲染的时候，需要调用react


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _schemaUtil = require('schema-util');

var _schemaUtil2 = _interopRequireDefault(_schemaUtil);

var _textfield = require('./textfield');

var _textfield2 = _interopRequireDefault(_textfield);

var _color = require('./color');

var _color2 = _interopRequireDefault(_color);

var _uploader = require('./uploader');

var _uploader2 = _interopRequireDefault(_uploader);

var _switch = require('./switch');

var _switch2 = _interopRequireDefault(_switch);

var _richText = require('./rich-text');

var _richText2 = _interopRequireDefault(_richText);

var _date = require('./date');

var _date2 = _interopRequireDefault(_date);

var _enum = require('./enum');

var _enum2 = _interopRequireDefault(_enum);

var _textarea = require('./textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _number = require('./number');

var _number2 = _interopRequireDefault(_number);

var _file = require('./file');

var _file2 = _interopRequireDefault(_file);

var _index = require('../util/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getItem(type, props) {
  var config = props.config;
  // 自定义类型
  if (config.fieldMap[type]) {
    return _react2.default.createElement(config.fieldMap[type], props);
  }

  // 根据不同的输入类型选择对应的处理模块
  switch (type) {
    case 'image':
      return _react2.default.createElement(_uploader2.default, props);
    case 'boolean':
      return _react2.default.createElement(_switch2.default, props);
    case 'richtext':
      return _react2.default.createElement(_richText2.default, props);
    case 'text':
      return _react2.default.createElement(_textarea2.default, props);
    case 'date':
      return _react2.default.createElement(_date2.default, props);
    case 'color':
      return _react2.default.createElement(_color2.default, props);
    case 'enum':
      return _react2.default.createElement(_enum2.default, props);
    case 'number':
      return _react2.default.createElement(_number2.default, props);
    case 'file':
      return _react2.default.createElement(_file2.default, props);
    case 'box':
      // box类型不渲染
      return null;
    case 'component':
      // 凤蝶 2.5 后不需要 component 类型
      return null;
    case 'object':
      {
        var ObjectField = require('./object');
        return _react2.default.createElement(ObjectField, props);
      }
    case 'array':
      {
        var ArrayField = require('./array').default;
        var data = props.data;
        if (data && !Array.isArray(data)) {
          data = (0, _index.addKey)(_schemaUtil2.default.mock(props.schema));
        }
        return _react2.default.createElement(ArrayField, _extends({}, props, { data: data }));
      }
    default:
      {
        return _react2.default.createElement(_textfield2.default, props);
      }
  }
}

module.exports = {
  getItem: getItem
};