'use strict';

var _inputNumber = require('antd/lib/input-number');

var _inputNumber2 = _interopRequireDefault(_inputNumber);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _schemaUtil = require('schema-util');

var _schemaUtil2 = _interopRequireDefault(_schemaUtil);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _form2.default.Item;

// 数值输入框
var NumberField = function (_React$Component) {
  _inherits(NumberField, _React$Component);

  function NumberField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, NumberField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = NumberField.__proto__ || Object.getPrototypeOf(NumberField)).call.apply(_ref, [this].concat(args))), _this), _this.handleChange = function (value) {
      var field = _this.props.field;
      // 兼容以前，返回 string 类型
      _this.props.onChange({ value: value, fields: [field] });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(NumberField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          data = _props.data,
          schema = _props.schema,
          field = _props.field,
          config = _props.config;

      var mockData = _schemaUtil2.default.mock(this.props.schema);
      var meta = schema.meta || {};
      var actData = isNaN(data) ? mockData : data;
      var errorMsg = config.validate(actData, schema.meta, schema.type);

      var cls = (0, _classnames2.default)({
        'ui-form-item': true,
        'field-string': true,
        'ui-form-item-error': errorMsg !== ''
      });

      var description = meta.description ? _react2.default.createElement(
        _text2.default,
        { showTooltip: true },
        schema.meta.description
      ) : null;

      return _react2.default.createElement(
        'div',
        { className: cls, key: field },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: schema.description },
            schema.description
          ),
          description
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content' },
          _react2.default.createElement(
            FormItem,
            {
              hasFeedback: true,
              help: errorMsg,
              validateStatus: errorMsg === '' ? '' : 'error'
            },
            _react2.default.createElement(_inputNumber2.default, { min: meta.min, max: meta.max,
              size: config.size,
              value: actData,
              step: meta.step,
              onChange: this.handleChange })
          )
        )
      );
    }
  }]);

  return NumberField;
}(_react2.default.Component);

module.exports = NumberField;