'use strict';

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _schemaUtil = require('schema-util');

var _schemaUtil2 = _interopRequireDefault(_schemaUtil);

var _addKey = require('../util/addKey');

var _addKey2 = _interopRequireDefault(_addKey);

var _evaluate = require('../util/evaluate');

var _evaluate2 = _interopRequireDefault(_evaluate);

var _item = require('./item');

var _item2 = _interopRequireDefault(_item);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

module.exports = function (_React$Component) {
  _inherits(FieldObject, _React$Component);

  function FieldObject() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FieldObject);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FieldObject.__proto__ || Object.getPrototypeOf(FieldObject)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (e) {
      var field = _this.props.field;
      if (field !== undefined) {
        e.fields.unshift(field);
      }

      _this.props.onChange(e);
    }, _this.onSelectItem = function (field) {
      return function () {
        _this.onChange({ selected: true, fields: [field] });
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FieldObject, [{
    key: 'getFieldTitle',


    // 嵌套时获取字段的标题
    value: function getFieldTitle() {
      var _props = this.props,
          field = _props.field,
          schema = _props.schema;

      if (field && typeof field !== 'number') {
        return _react2.default.createElement(
          'div',
          { className: 'ui-title' },
          schema.description
        );
      }
      return null;
    }
  }, {
    key: 'isPlainObject',
    value: function isPlainObject() {
      var schema = this.props.schema;

      var total = { array: 0, object: 0 };

      Object.keys(schema.properties).forEach(function (o) {
        var type = schema.properties[o].type;
        if (type === 'array') {
          total.array += 1;
        }

        if (type === 'object') {
          total.object += 1;
        }
      });
      // 一个数组的情况，不折叠
      // 存在对象、或者多个数组的情况折叠
      return total.object > 0 || total.array > 1;
    }
  }, {
    key: 'getItem',
    value: function getItem(key) {
      var _props2 = this.props,
          schema = _props2.schema,
          data = _props2.data,
          config = _props2.config,
          getCustomField = _props2.getCustomField;

      var props = schema.properties[key];
      var type = props.type;

      var isPlainObject = this.isPlainObject();

      var itemVal = void 0;
      if (typeof data === 'undefined') {
        itemVal = (0, _addKey2.default)(_schemaUtil2.default.mock(props));
      } else {
        itemVal = data[key];
      }

      var itemProps = {
        field: key,
        data: itemVal,
        schema: props,
        parentData: data,
        onChange: this.onChange,
        onClick: this.props.onClick,
        config: config
      };

      var ifState = props.meta ? props.meta.if : null;

      if (ifState) {
        try {
          var shouldShow = (0, _evaluate2.default)(data, ifState);
          if (!shouldShow) {
            return null;
          }
        } catch (e) {
          // 忽略错误
        }
      }

      // 自定义字段，基于 schema 判断逻辑
      if (getCustomField) {
        var customField = getCustomField(itemProps, schema);
        // 不等于 false 的情况
        if (customField !== false) {
          return customField;
        }
      }

      if (isPlainObject && (type === 'object' || type === 'array')) {
        return _react2.default.createElement(
          'div',
          { className: 'ui-object-folder', key: key, onClick: this.onSelectItem(key) },
          _react2.default.createElement(
            'div',
            null,
            props.description
          ),
          _react2.default.createElement(
            'span',
            { className: 'ui-object-folder-editor', name: key, title: config.locale.EDIT_OBJECT },
            _react2.default.createElement(_icon2.default, { type: 'edit' })
          )
        );
      }

      var item = _item2.default.getItem(type, itemProps);
      return _react2.default.createElement(
        'div',
        { key: key, className: 'field-item field-' + type },
        item
      );
    }
  }, {
    key: 'renderGroups',
    value: function renderGroups() {
      var _this2 = this;

      var _props3 = this.props,
          schema = _props3.schema,
          getGroupsRule = _props3.getGroupsRule;

      var properties = schema.properties;
      var isPlainObject = this.isPlainObject();
      // 用来分组 object、array
      var objectGroup = [];

      var items = Object.keys(properties).map(function (field, index) {
        var type = properties[field].type;
        var itemField = _this2.getItem(field);

        if (isPlainObject && (type === 'object' || type === 'array')) {
          // 当某个字段类型为 object|array 时，把此字段放入 group，返回 null
          objectGroup.push(itemField);
          return null;
        }

        // 当下一个字段类型不是 object|array 时，如果 objectGroup 为空则返回当前的 field
        if (objectGroup.length === 0) {
          return itemField;
        }

        // 当下一个字段类型不是 object|array 时，如果 objectGroup 非空则 objectGroup + field
        var data = _react2.default.createElement(
          'div',
          { key: 'object-group-' + index, className: 'ui-object-group' },
          objectGroup.map(function (d) {
            return d;
          })
        );
        // 清空当前 group
        objectGroup = [];

        return [data, itemField];
      });

      // 所有的字段都遍历完成后，再追加 objectGroup 还有数据（如果有的话）
      if (objectGroup.length) {
        items = items.concat(_react2.default.createElement(
          'div',
          { key: 'object-group-' + Date.now(), className: 'ui-object-group' },
          objectGroup
        ));
        objectGroup = [];
      }

      if (getGroupsRule) {
        return getGroupsRule(items);
      }

      return items;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'ui-object' },
        this.getFieldTitle(),
        this.renderGroups()
      );
    }
  }]);

  return FieldObject;
}(_react2.default.Component);