'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var xss = require('xss');

var toolbarGroups = [{ name: 'clipboard', groups: ['clipboard', 'undo'] }, { name: 'editing', groups: ['find', 'selection'] }, { name: 'links' }, { name: 'insert' }, { name: 'forms' }, { name: 'tools' }, { name: 'document', groups: ['mode', 'document', 'doctools'] }, { name: 'others' }, { name: 'basicstyles', groups: ['basicstyles', 'cleanup'] }, { name: 'paragraph', groups: ['list', 'indent', 'blocks', 'align', 'bidi'] }, { name: 'styles' }, { name: 'colors' }, { name: 'about' }];

var toolbar = [{ name: 'clipboard', items: ['PasteText', 'PasteFromWord', '-', 'Undo', 'Redo'] }, { name: 'editing', items: [] }, { name: 'links', items: ['Link', 'Unlink', 'Anchor'] }, { name: 'insert', items: ['Image'] }, { name: 'tools', items: ['Maximize'] }, { name: 'document', items: [] }, { name: 'colors', items: ['TextColor'] }, { name: 'basicstyles', items: ['Bold', 'Italic', 'Strike', '-', 'RemoveFormat'] }, { name: 'paragraph', items: ['NumberedList', 'BulletedList', 'JustifyLeft', 'JustifyCenter', 'JustifyRight'] }, { name: 'styles', items: ['Format'] }];

/**
 * 富文本输入框
 */

var RichText = function (_React$Component) {
  _inherits(RichText, _React$Component);

  function RichText() {
    _classCallCheck(this, RichText);

    var _this = _possibleConstructorReturn(this, (RichText.__proto__ || Object.getPrototypeOf(RichText)).call(this));

    _this.customXSS = new xss.FilterXSS({
      whiteList: {
        a: ['target', 'href', 'title', 'style'],
        abbr: ['title'],
        address: [],
        area: ['shape', 'coords', 'href', 'alt'],
        article: [],
        aside: [],
        audio: ['autoplay', 'controls', 'loop', 'preload', 'src'],
        b: ['style'],
        bdi: ['dir'],
        bdo: ['dir'],
        big: [],
        blockquote: ['cite'],
        br: [],
        caption: [],
        center: [],
        cite: [],
        code: [],
        col: ['align', 'valign', 'span', 'width'],
        colgroup: ['align', 'valign', 'span', 'width'],
        dd: [],
        del: ['datetime'],
        details: ['open'],
        div: ['style'],
        dl: [],
        dt: [],
        em: [],
        font: ['color', 'size', 'face', 'style'],
        footer: [],
        h1: ['style'],
        h2: ['style'],
        h3: ['style'],
        h4: ['style'],
        h5: ['style'],
        h6: ['style'],
        header: ['style'],
        hr: [],
        i: [],
        img: ['src', 'alt', 'title', 'width', 'height', 'style'],
        ins: ['datetime'],
        li: [],
        mark: [],
        nav: [],
        ol: [],
        p: ['style'],
        pre: [],
        s: [],
        section: [],
        small: [],
        span: ['style'],
        sub: [],
        sup: [],
        strong: ['style'],
        table: ['width', 'border', 'align', 'valign'],
        tbody: ['align', 'valign'],
        td: ['width', 'rowspan', 'colspan', 'align', 'valign'],
        tfoot: ['align', 'valign'],
        th: ['width', 'rowspan', 'colspan', 'align', 'valign'],
        thead: ['align', 'valign'],
        tr: ['rowspan', 'align', 'valign'],
        tt: [],
        u: [],
        ul: [],
        video: ['autoplay', 'controls', 'loop', 'preload', 'src', 'height', 'width']
      },
      css: {
        whiteList: {
          width: true,
          height: true,
          color: true,
          'font-size': true,
          'text-align': true,
          'text-decoration': true
        }
      }
    });

    _this.richTextRef = _react2.default.createRef();
    _this.state = { EDITOR: null };
    return _this;
  }

  _createClass(RichText, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var config = this.props.config;
      var self = this;
      // 如果 window.CKEDITOR 已经存在,则不进行重复加载，直接生成新的 CKEDITOR
      if (window.CKEDITOR) {
        createRichText();
      } else {
        var url = 'https://a.alipayobjects.com/g/fengdie/ckeditor/4.5.31/ckeditor.js';
        var script = require('scriptjs');
        script(url, function () {
          richTextConfig();
          createRichText();
        });
      }

      // 初始化时对富文本框的样式进行设定
      function richTextConfig() {
        var CKEDITOR = window.CKEDITOR;
        CKEDITOR.config.toolbarGroups = toolbarGroups;
        CKEDITOR.config.toolbar = toolbar;

        CKEDITOR.config.height = 350;
        CKEDITOR.config.width = 'auto';
        CKEDITOR.config.fontFamily = '"Helvetica Neue",Helvetica,STHeiTi,sans-serif';
        // contentsCss: 给 CKEDITOR 的 iframe 编辑区的 css 样式
        // removeDialogTabs: 移除部分小组件的小标签，例如上传功能的高级和链接 tab 里
        CKEDITOR.config.contentsCss = ['https://os.alipayobjects.com/rmsportal/XCdqKNiTHAdufcg.css',
        // TODO 这里需要修改下，暂时用这里的地址吧，蜻蜓没法传一个文件
        'https://os.alipayobjects.com/rmsportal/DAOmvwmFHmiGbyW.css'];

        CKEDITOR.config.allowedContent = true;
        CKEDITOR.config.removeDialogTabs = 'image:advanced;image:Link;link:advanced';
      }

      // 初始化富文本框
      function createRichText() {
        var CKEDITOR = window.CKEDITOR;
        var CKEditorName = CKEDITOR.replace(self.richTextRef.current, {
          customConfig: '',
          extraPlugins: 'uploadimage',
          filebrowserImageUploadUrl: config.uploadApiForRichText
        }).name;
        var EDITOR = CKEDITOR.instances[CKEditorName];

        EDITOR.on('change', function (e) {
          // 这里的换行符会导致nunjucks解析报错，所以需要自己手动筛选掉
          var html = e.editor.getData().replace(/[\n\r]/g, '');
          var field = self.props.field;
          self.props.onChange({ value: html, fields: [field] });
        });

        self.setState({
          EDITOR: EDITOR
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          schema = _props.schema,
          field = _props.field,
          data = _props.data,
          modified = _props.modified;

      var xssFilterData = this.customXSS.process(data);

      // 使用描述
      var description = schema.meta && schema.meta.description ? _react2.default.createElement(
        _text2.default,
        { showTooltip: true },
        schema.meta.description
      ) : null;

      // 如果已经加载，则文本框更新为新的内容
      var EDITOR = this.state.EDITOR;
      if (EDITOR && !modified) {
        // 保存成功后，回显数据库最新的内容
        EDITOR.setData(xssFilterData, {
          internal: true
        });
      }

      return _react2.default.createElement(
        'div',
        { className: 'ui-form-item field-string', key: field },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: schema.description || '富文本' },
            schema.description || '富文本'
          ),
          description
        ),
        _react2.default.createElement('div', { className: 'rich-text', ref: this.richTextRef, dangerouslySetInnerHTML: { __html: xssFilterData } })
      );
    }
  }]);

  return RichText;
}(_react2.default.Component);

module.exports = RichText;