'use strict';

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _form2.default.Item;

// 文本输入框

var Textarea = function (_React$Component) {
  _inherits(Textarea, _React$Component);

  function Textarea() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Textarea);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Textarea.__proto__ || Object.getPrototypeOf(Textarea)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (e) {
      var field = _this.props.field;
      var value = e.target.value;
      _this.props.onChange({ value: value, fields: [field] });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Textarea, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          field = _props.field,
          data = _props.data,
          schema = _props.schema,
          config = _props.config;

      var meta = schema.meta;
      var maxLength = meta ? meta.maxLength : null;

      var validate = config.validate;
      var errorMsg = validate(data, schema.meta, schema.type);

      var description = meta && meta.description ? _react2.default.createElement(
        _text2.default,
        { showTooltip: true },
        schema.meta.description
      ) : null;

      // 渲染
      return _react2.default.createElement(
        'div',
        { className: 'ui-form-item field-string', key: field },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: schema.description },
            schema.description
          ),
          description
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content' },
          _react2.default.createElement(
            FormItem,
            {
              hasFeedback: true,
              help: errorMsg,
              validateStatus: errorMsg === '' ? '' : 'error'
            },
            _react2.default.createElement(_input2.default.TextArea, {
              autosize: { minRows: 3, maxRows: 6 },
              onChange: this.onChange,
              value: data,
              maxLength: maxLength
            })
          )
        )
      );
    }
  }]);

  return Textarea;
}(_react2.default.Component);

module.exports = Textarea;