'use strict';

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _text = require('./text');

var _text2 = _interopRequireDefault(_text);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _form2.default.Item;

// 文本输入框
var Textfield = function (_React$Component) {
  _inherits(Textfield, _React$Component);

  function Textfield() {
    _classCallCheck(this, Textfield);

    var _this = _possibleConstructorReturn(this, (Textfield.__proto__ || Object.getPrototypeOf(Textfield)).call(this));

    _this.onChange = function (e) {
      var value = e.target.value;
      var field = _this.props.field;
      _this.props.onChange({ value: value, fields: [field] });
    };

    _this.onBlur = function (e) {
      var value = e.target.value;
      // 数据 trim
      var data = _this.props.data.trim();
      if (data !== value) {
        var field = _this.props.field;
        _this.props.onChange({ value: data, fields: [field] });
      }
    };

    _this.state = {
      errorMsg: ''
    };
    return _this;
  }

  _createClass(Textfield, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          field = _props.field,
          schema = _props.schema,
          config = _props.config,
          data = _props.data;

      var validate = config.validate;
      var errorMsg = validate(data, schema.meta, schema.type);

      var cls = (0, _classnames2.default)({
        'ui-form-item': true,
        'field-string': true,
        'ui-form-item-error': errorMsg !== ''
      });

      var description = schema.meta && schema.meta.description ? _react2.default.createElement(
        _text2.default,
        { showTooltip: true },
        schema.meta.description
      ) : null;

      // 渲染
      return _react2.default.createElement(
        'div',
        { className: cls, key: field },
        _react2.default.createElement(
          'div',
          { className: 'ui-label' },
          _react2.default.createElement(
            'span',
            { className: 'ui-label-title', title: schema.description },
            schema.description
          ),
          description
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-content' },
          _react2.default.createElement(
            FormItem,
            {
              hasFeedback: true,
              help: errorMsg,
              validateStatus: errorMsg === '' ? '' : 'error'
            },
            _react2.default.createElement(_input2.default, {
              size: config.size,
              placeholder: this.props.placeholder,
              value: data,
              onChange: this.onChange,
              onBlur: this.onBlur
            })
          )
        )
      );
    }
  }]);

  return Textfield;
}(_react2.default.Component);

module.exports = Textfield;