'use strict';

var _breadcrumb = require('antd/lib/breadcrumb');

var _breadcrumb2 = _interopRequireDefault(_breadcrumb);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _schemaUtil = require('schema-util');

var _schemaUtil2 = _interopRequireDefault(_schemaUtil);

var _item = require('./fields/item');

var _item2 = _interopRequireDefault(_item);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _validate = require('./util/validate');

var _validate2 = _interopRequireDefault(_validate);

var _clone = require('./util/clone');

var _clone2 = _interopRequireDefault(_clone);

var _getArrayTitle = require('./util/getArrayTitle');

var _getArrayTitle2 = _interopRequireDefault(_getArrayTitle);

var _util = require('./util/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// 对数组增加唯一的 key


var defaultConfig = {
  excelImport: false, // 开启 excel 导入导出功能
  uploadApi: '/api/upload',
  uploadApiForRichText: '/api/upload?type=richText',
  // custom field type
  fieldMap: {},
  validate: _validate2.default,
  uploadImgSize: 512000, // 500KB
  // 只允许上传图片不允许输入 url
  imageUploadOnly: false,
  lang: 'zh_cn',
  size: 'large'
};

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor(props) {
    _classCallCheck(this, Editor);

    var _this = _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).call(this, props));

    _this.onItemSelect = function (e) {
      _this.setState({ selected: _this.state.selected.concat(e.fields) });
    };

    _this.onChange = function (e) {
      if (e.selected) {
        _this.onItemSelect(e);
        return;
      }

      if (_this.props.onBeforeChange) {
        _this.props.onBeforeChange(e);
      }

      e.fields = _this.state.selected.concat(e.fields).filter(function (o) {
        return o !== undefined;
      });
      // clone data
      var data = JSON.parse(JSON.stringify(_this.getValue()));
      var fields = e.fields.slice();
      var tmp = data;
      var tmpSchema = _this.props.schema;
      var last = fields.pop();

      // modify array
      if (last === undefined && tmpSchema.type === 'array') {
        data = e.value;
      } else {
        // modify item field
        fields.forEach(function (item) {
          if (typeof item !== 'number') {
            tmpSchema = tmpSchema.properties[item];
          }

          // if data is null, mock data 或 非数组或对象，都需要 mock
          if (typeof tmp[item] === 'undefined' || _typeof(tmp[item]) !== 'object') {
            tmp[item] = _schemaUtil2.default.mock(tmpSchema);
          }

          tmp = tmp[item];
        });
        tmp[last] = e.value;
      }

      if (_this.props.onChange) {
        _this.props.onChange(data, e);
      }

      _this.lastItem = e.fields;
      if (_this.state.data) {
        _this.setState({ data: data });
      }
    };

    _this.onClick = function (data) {
      if (_this.props.onClick) {
        _this.props.onClick(data);
      }
    };

    _this.state = { data: props.data, selected: [] };
    _this.lastItem = null;
    _this.__uid = (0, _util.uid)(20);

    _this.devtoolInit();
    return _this;
  }

  _createClass(Editor, [{
    key: 'devtoolInit',
    value: function devtoolInit() {
      var _this2 = this;

      (0, _util.addDevToolApi)(this.__uid, {
        importData: function importData(data) {
          if (_this2.props.onChange) {
            _this2.props.onChange(data, {});
          }
          if (_this2.state.data) {
            _this2.setState({ data: data });
          }
        },
        exportData: function exportData() {
          return _this2.getValue();
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      (0, _util.removeDevToolApi)(this.__uid);
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      var value = this.props.value;
      // 默认去 props.value ，否则去 state.data 内部维护数据
      var data = value || this.state.data;
      if (!data) {
        // if data is null, then mock data first
        data = _schemaUtil2.default.mock(this.props.schema);
      }
      return data;
    }
  }, {
    key: 'validate',
    value: function validate(fn, locale) {
      var _this3 = this;

      return function (value, meta, type) {
        var errorMsg = '';

        switch (type) {
          case 'image':
            if (value && !/^[\w\d\_-]*:\/\/[^\s]*$/gi.test(value)) {
              errorMsg = locale.IMAGE_FORMAT_ERROR;
            }
            break;
          case 'url':
            if (value && /\s/g.test(value)) {
              errorMsg = locale.URL_FORMAT_ERROR;
            }
            break;
          default:
            errorMsg = fn(value, meta, type, locale);
        }

        if (errorMsg && _this3.props.onError) {
          _this3.props.onError({
            errorMsg: errorMsg,
            fieldPath: (0, _clone2.default)(_this3.lastItem)
          });
        }
        return errorMsg;
      };
    }
  }, {
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.schema !== this.props.schema) {
        this.setState({ data: nextProps.data, selected: [] });
      }
    }
  }, {
    key: 'getDataAndSchema',
    value: function getDataAndSchema() {
      var schema = this.props.schema;
      var data = this.getValue();
      this.state.selected.forEach(function (item) {
        if (typeof item !== 'number') {
          schema = schema.properties[item];
        } else {
          // 数组的元素，把类型改为 object 既可
          schema = (0, _objectAssign2.default)({}, schema, { type: 'object' });
        }
        data = data[item];
      });
      return { data: data, schema: schema };
    }
  }, {
    key: 'stepBack',
    value: function stepBack(index) {
      var _this4 = this;

      return function () {
        var selected = _this4.state.selected.slice();
        while (index !== selected.length) {
          selected.pop();
        }
        _this4.setState({ selected: selected });
      };
    }
  }, {
    key: 'getNavBar',
    value: function getNavBar() {
      var _this5 = this;

      var _props = this.props,
          schema = _props.schema,
          getNavBar = _props.getNavBar,
          value = _props.value;
      var selected = this.state.selected;

      var data = this.getValue();
      var len = selected.length - 1;
      var getNavBarItem = function getNavBarItem(title, index, needHref) {
        if (!needHref) {
          return _react2.default.createElement(
            _breadcrumb2.default.Item,
            { key: index },
            title
          );
        }
        return _react2.default.createElement(
          _breadcrumb2.default.Item,
          { key: index, onClick: _this5.stepBack(index) },
          title
        );
      };

      var navbarItemList = [getNavBarItem(schema.description, 0, len > -1, selected[0])];
      selected.forEach(function (key, i) {
        data = data[key];
        if (typeof key !== 'number') {
          schema = schema.properties[key];
          navbarItemList.push(getNavBarItem(schema.description, i + 1, i < len, selected[i + 1]));
        } else {
          navbarItemList.push(getNavBarItem((0, _getArrayTitle2.default)(data, schema, value), i + 1, i < len, selected[i + 1]));
        }
      });

      var nav = _react2.default.createElement(
        _breadcrumb2.default,
        { separator: '>' },
        navbarItemList
      );

      if (typeof getNavBar === 'function') {
        return getNavBar(nav);
      }

      return nav;
    }
  }, {
    key: 'render',
    value: function render() {
      var _getDataAndSchema = this.getDataAndSchema(),
          schema = _getDataAndSchema.schema,
          data = _getDataAndSchema.data;

      var config = (0, _objectAssign2.default)({
        rootData: this.getValue(),
        paths: this.state.selected
      }, defaultConfig, this.props.config);

      var cls = (0, _classnames2.default)({
        'schema-editor': true,
        'schema-editor-group': this.state.selected.length > 0
      });

      var locale = require('./i18n/' + config.lang);
      config.locale = config.locale || locale;
      config.validate = this.validate(config.validate, locale);

      var props = {
        schema: schema,
        data: data,
        onChange: this.onChange,
        onClick: this.onClick,
        config: config
      };

      return _react2.default.createElement(
        'div',
        { className: cls, 'data-schema-uid': this.__uid },
        _react2.default.createElement(
          'div',
          { className: 'schema-editor-main' },
          this.getNavBar(),
          _react2.default.createElement(
            'div',
            { className: 'schema-editor-scroll' },
            _react2.default.createElement(
              'div',
              { className: 'schema-editor-container' },
              _item2.default.getItem(schema.type, props)
            )
          )
        )
      );
    }
  }]);

  return Editor;
}(_react2.default.Component);

Editor.propTypes = {
  schema: _propTypes2.default.object,
  config: _propTypes2.default.object
};

module.exports = Editor;