'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = add;
var isPlainObject = require('is-plain-object');

function add(datas) {
  if (!datas) {
    return datas;
  }

  if (Array.isArray(datas)) {
    var exitKeys = {};
    return datas.map(function (data, index) {
      // dva-immer 把 data 变成了只读的所以这里要复制一份数据
      var newData = _extends({}, data);
      if (isPlainObject(newData) && !newData.__key) {
        var _add = 1;
        // 防止 key 冲突
        var key = index + _add;
        while (exitKeys[key]) {
          _add += 1;
          key = index + _add;
        }

        if (!exitKeys[key]) {
          newData.__key = key;
          exitKeys[key] = true;
        }
      } else {
        exitKeys[newData.__key] = true;
      }
      return newData;
    });
  }

  if (isPlainObject(datas)) {
    Object.keys(datas).forEach(function (key) {
      add(datas[key]);
    });
  }

  return datas;
}