'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = function (data, schema, rootData) {
  // 查找顺序，title -> name -> 第一个元素
  // 展示，其他折叠起来
  var showKey = void 0;

  // 指定 key 展示
  if (schema.meta && schema.meta.showKey) {
    showKey = schema.meta.showKey;
    return data[showKey];
  }

  if (data.title) {
    showKey = 'title';
  } else if (data.name) {
    showKey = 'name';
  } else {
    showKey = Object.keys(data)[0];
  }

  if (!schema.properties[showKey]) {
    showKey = Object.keys(schema.properties)[0];
  }

  var showKeyType = schema.properties[showKey].type;
  if (_typeof(data[showKey]) === 'object') {
    //  字段类型为 object/array/box 等
    return schema.description + (data.__key || '');
  } else if (showKeyType === 'enum') {
    var showKeyItems = schema.properties[showKey].items || [];
    var source = schema.properties[showKey].meta ? schema.properties[showKey].meta.source : null;
    if (source && showKeyItems.length === 0 && rootData) {
      var ROOT = '$root.';
      if (source.indexOf(ROOT) === 0) {
        source = source.slice(ROOT.length);
        if (rootData[source]) {
          showKeyItems = rootData[source];
        }
      }
    }

    var val = data[showKey];
    var selectedItem = showKeyItems.filter(function (o) {
      return o.value === val;
    })[0];
    return selectedItem ? selectedItem.label : val;
  } else if (showKeyType === 'date') {
    var m = (0, _moment2.default)(data[showKey]);
    return m.isValid() ? (0, _moment2.default)(data[showKey]).format('YYYY-MM-DD HH:mm') : data[showKey];
  }
  return data[showKey];
};

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }