'use strict';

/*
 * 服务端安全过滤
 * @params data {JSON} schemaJSON 数据
 * @params data {SCHEMA} schema
 */

module.exports = {
  /*
   * 过滤 json 数据中非白名单的图片
   * @param {string} jsonString string 格式的 json 数据
   * @param {Array[string]} whiteListDomain 域名白名单列表
   */
  safeImageUrl: function safeImageUrl(jsonString, whiteListDomain) {
    if (!Array.isArray(whiteListDomain) || whiteListDomain.length === 0) {
      return jsonString;
    }

    // 从字符串中匹配出图片
    return jsonString.replace(/\/\/([^"]*.(png|jpg|jpeg|gif|webp))/gi, function (originStr, matchStr) {
      var domain = matchStr.split('/')[0];
      if (whiteListDomain.indexOf(domain) === -1) {
        // 替换为空白图片
        return '//gw.alipayobjects.com/zos/rmsportal/uFspnShmRpAcxtAjVwlZ.gif';
      }
      return '//' + matchStr;
    });
  }
};