import React from 'react';
import Text from './text';
import { Switch } from 'antd';

class Switcher extends React.Component {
  changeValue = value => {
    const field = this.props.field;
    this.props.onChange({ value, fields: [ field ] });
  }

  render() {
    const { data, field, schema } = this.props;

    const description = schema.meta && schema.meta.description
      ? <Text showTooltip>{ schema.meta.description }</Text>
      : null;

    return (
      <div className={'ui-form-item item-boolean'} key={field}>
        <div className="ui-label">
          <span className="ui-label-title" title={schema.description}>{schema.description}</span>
          { description }
        </div>
        <Switch checked={data} onChange={this.changeValue} />
      </div>
    );
  }
}

module.exports = Switcher;
