const isPlainObject = require('is-plain-object');

export default function add(datas) {
  if (!datas) {
    return datas;
  }

  if (Array.isArray(datas)) {
    const exitKeys = {};
    return datas.map(function(data, index) {
      // dva-immer 把 data 变成了只读的所以这里要复制一份数据
      const newData = { ...data };
      if (isPlainObject(newData) && !newData.__key) {
        let add = 1;
        // 防止 key 冲突
        let key = index + add;
        while (exitKeys[key]) {
          add += 1;
          key = index + add;
        }

        if (!exitKeys[key]) {
          newData.__key = key;
          exitKeys[key] = true;
        }
      } else {
        exitKeys[newData.__key] = true;
      }
      return newData;
    });
  }

  if (isPlainObject(datas)) {
    Object.keys(datas).forEach(function(key) {
      add(datas[key]);
    });
  }

  return datas;
}
