import React from 'react';
import classnames from 'classnames';
import { Tooltip } from 'antd';
import { CopyToClipboard } from 'react-copy-to-clipboard';

class Copy extends React.Component {
  constructor() {
    super();
    this.state = {
      copied: false,
    };
  }

  handleCopied() {
    this.setState({ copied: true }, () => setTimeout(() => this.setState({ copied: false }), 2000));
  }

  render() {
    const { text, className, description, children } = this.props;
    const { copied } = this.state;
    const cls = classnames('common-copy', className);
    return (
      <CopyToClipboard text={ text } onCopy={ () => this.handleCopied() }>
        <span className={ cls }>
          <Tooltip title={ copied ? '已复制' : `${description || '复制'}` } placement="top" mouseLeaveDelay={ 0 }>
            <span style={ { cursor: 'pointer' } }>
              { children }
            </span>
          </Tooltip>
        </span>
      </CopyToClipboard>
    );
  }

}

module.exports = Copy;
