import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';

Enzyme.configure({ adapter: new Adapter() });

import ColorField from '../lib/fields/color';

describe('fields/color', () => {
  it('normal', () => {
    const props = {
      field: 'color',
      data: '',
      schema: {
        meta: {
          description: '颜色',
        },
      },
      onChange: data => {
        data.should.eql({ value: 'rgb(255, 255, 0)', fields: [ 'color' ] });
      },
    };
    const field = mount(<ColorField {...props} />);

    field.find('Popover').length.should.eql(1);
    field.find('.color-string').simulate('click');

    field.find('Sketch').at(0).props()
      .onChange('#ffff00');
  });

});
