import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import DateField from '../lib/fields/date';

describe('fields/switch', () => {
  it('normal', () => {
    const props = {
      field: 'date',
      data: '2018-12-12 12:12:12',
      schema: {
        meta: {
          description: '出发时间',
        },
      },
      config: {
        validate: () => { return null; },
      },
      onChange: data => {
        data.should.eql({ value: 1513051932000, fields: [ 'date' ] });
      },
    };
    const field = mount(<DateField {...props} />);

    field.find('PickerWrapper').length.should.eql(1);

    field.find('PickerWrapper').at(0).props()
      .onChange('2017-12-12 12:12:12');
  });

});
