import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import EnumField from '../lib/fields/enum';

describe('fields/enum', () => {
  it('multiple enum', () => {
    const props = {
      field: 'type',
      data: 'a',
      schema: {
        type: 'enum',
        description: '枚举类型',
        items: [
          {
            label: 'value A',
            value: 'a',
          },
          {
            label: 'value B',
            value: 'b',
          },
          {
            label: 'value B',
            value: 'a',
          },
          {
            label: 'value C',
            value: 'c',
          },
        ],
        meta: {
          multiple: true,
          description: '枚举类型',
        },
      },
      onChange: data => {
        data.should.eql({ value: 'b', fields: [ 'type' ] });
      },
    };
    const field = mount(<EnumField {...props} />);

    field.find('SelectTrigger').length.should.eql(1);

    field.find('Select').at(0).props()
      .onChange('b');
  });

});
