import 'should';
import React from 'react';
import sinon from 'sinon';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import RichTextField from '../lib/fields/rich-text';

const sandbox = sinon.sandbox.create();

describe('fields/text', () => {
  beforeEach(() => {
    sandbox.restore();
  });

  it('normal', () => {
    const props = {
      field: 'text',
      data: '<p>描述文案</p>',
      modified: false,
      schema: {
        description: '正文内容',
      },
    };
    delete global.window.CKEDITOR;
    const field = mount(<RichTextField {...props} />);

    field.find('.rich-text').length.should.eql(1);
  });
});
