import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import SwitchField from '../lib/fields/switch';

describe('fields/switch', () => {
  it('normal', () => {
    const props = {
      field: 'isOpen',
      data: false,
      schema: {
        meta: {
          description: '是否开启',
        },
      },
      onChange: data => {
        data.should.eql({ value: true, fields: [ 'isOpen' ] });
      },
    };
    const field = mount(<SwitchField {...props} />);

    field.find('Text').length.should.eql(1);

    field.find('Switch').at(0).props()
      .onChange(true);
  });

});
