import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import TextField from '../lib/fields/text';

describe('fields/text', () => {
  it('length is -1', () => {
    const props = {
      length: -1,
      children: '这是一段测试文案',
      tail: '...',
      tailClassName: 'more',
      className: 'text-class-name',
      showTooltip: false,
    };
    const field = mount(<TextField {...props} />);

    field.find('Popover').length.should.eql(0);
  });

  it('showTooltip: false', () => {
    const props = {
      length: 4,
      children: '这是一段测试文案',
      tail: '...',
      tailClassName: 'more',
      className: 'text-class-name',
      showTooltip: false,
    };
    const field = mount(<TextField {...props} />);

    field.find('Popover').length.should.eql(0);
  });

  it('normal', () => {
    const props = {
      length: 5,
      children: '这是一段测试文案',
      tail: '...',
      tailClassName: 'more',
      className: 'text-class-name',
      showTooltip: true,
    };
    const field = mount(<TextField {...props} />);

    field.find('p').at(0).text().should.eql('这是...');

    field.find('Popover').props().content.should.eql('这是一段测试文案');
    field.find('Popover').props().overlayClassName.should.eql('text-block-popover');
  });

});
