import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import TextareaField from '../lib/fields/textarea';

describe('fields/switch', () => {
  it('normal', () => {
    const props = {
      field: 'content',
      data: '一段多行文本框',
      schema: {
        meta: {
          description: '描述',
        },
      },
      config: {
        validate: () => { return null; },
      },
      onChange: data => {
        data.should.eql({ value: '多行文本框', fields: [ 'content' ] });
      },
    };
    const field = mount(<TextareaField {...props} />);

    field.find('TextArea').length.should.eql(1);

    field.find('TextArea').at(0).props()
      .onChange({ target: { value: '多行文本框' } });
  });

});
