import 'should';
import React from 'react';
import Enzyme, { mount } from 'enzyme';
import Adapter from 'enzyme-adapter-react-16';


Enzyme.configure({ adapter: new Adapter() });

import TextField from '../lib/fields/textfield';

describe('fields/textfield', () => {
  it('normal', () => {
    const inputValues = [];
    const props = {
      field: 'text',
      schema: {
        description: '单行文本框描述',
      },
      config: {
        validate: () => {
          return null;
        },
      },
      onChange: val => { inputValues.push(val); },
      data: '单行文本框',
    };
    const field = mount(<TextField {...props} />);

    field.find('Input').length.should.eql(1);

    const textProps = field.find('Input').at(0).props();

    textProps.onBlur({ target: { value: 'blur value.' } });
    textProps.onChange({ target: { value: 'change value.' } });

    inputValues.should.eql([
      { value: '单行文本框', fields: [ 'text' ] },
      { value: 'change value.', fields: [ 'text' ] },
    ]);
  });

});
